Index: /branches/2.0/expressoMail1_2/js/common_functions.js
===================================================================
--- /branches/2.0/expressoMail1_2/js/common_functions.js	(revision 2758)
+++ /branches/2.0/expressoMail1_2/js/common_functions.js	(revision 2813)
@@ -37,5 +37,5 @@
 	var content_folders = Element("content_folders");
 	var clientHeight = ((window.innerHeight ? window.innerHeight : document.body.offsetHeight) - 8);
-	var clientWidth = ((window.innerWidth ? window.innerWidth : document.body.offsetWidth));		
+	var clientWidth = window.innerWidth ? window.innerWidth : document.body.offsetWidth;		
 	if(divScrollMain){
 		divScrollMain.style.height = (clientHeight - (findPosY(divScrollMain) + (table_message.clientHeight ? table_message.clientHeight : table_message.offsetHeight))) + "px";
@@ -52,5 +52,5 @@
 			if(div_scroll){
 				div_scroll.style.height = (clientHeight - (findPosY(div_scroll) + (table_message.clientHeight ? table_message.clientHeight : table_message.offsetHeight)+5)) + "px";
-				div_scroll.style.width = (clientWidth - (findPosX(div_scroll)+10)) + "px";
+				div_scroll.style.width = (clientWidth - (findPosX(div_scroll)+15)) + "px";
 			}
 		}
Index: /branches/2.0/expressoMail1_2/js/messages_controller.js
===================================================================
--- /branches/2.0/expressoMail1_2/js/messages_controller.js	(revision 2202)
+++ /branches/2.0/expressoMail1_2/js/messages_controller.js	(revision 2813)
@@ -87,5 +87,5 @@
 	
 	messages_proxy.prototype.is_local_folder = function(folder) {
-		if(folder.indexOf("local_")==-1)
+		if(typeof(folder) == "undefined" || folder.indexOf("local_")==-1)
 			return false;
 		return true;
Index: /branches/2.0/expressoMail1_2/js/draw_api.js
===================================================================
--- /branches/2.0/expressoMail1_2/js/draw_api.js	(revision 2773)
+++ /branches/2.0/expressoMail1_2/js/draw_api.js	(revision 2813)
@@ -356,6 +356,8 @@
 //		cExecute ("$this.imap_functions.get_range_msgs2&folder="+current_folder+"&msg_range_begin=1&msg_range_end="+preferences.max_email_per_page+"&sort_box_type="+sort_box_type+ "&search_box_type="+ search_box_type +"&sort_box_reverse="+sort_box_reverse+"", handler_draw_box);
 	}
-	else
+	else {
 		alternate_border(0);
+		resizeWindow();
+	}
 }
 
@@ -501,5 +503,5 @@
 	
 	table_message_header_box = document.getElementById("table_message_header_box_"+numBox);
-	if (table_message_header_box == null){
+	if (table_message_header_box == null){		
 		var table_element = document.createElement("TABLE");
 		var tbody_element = document.createElement("TBODY");
@@ -546,5 +548,5 @@
 		td_element4.align = "left";
 		td_element4.innerHTML = get_lang("Subject");
-	
+		
 		td_element5 = document.createElement("TD");
 		td_element5.setAttribute("width", "14%");
@@ -584,5 +586,5 @@
 	table_element.id = "table_box";
 	table_element.className = "table_box";
-	table_element.borderColorDark = "#bbbbbb";
+	table_element.borderColorDark = "#bbbbbb";	
 	table_element.frame = "void";
 	table_element.rules = "rows";
@@ -1112,4 +1114,5 @@
 	var tbody_message = document.createElement("TBODY");
 	table_message.border = "0";
+	table_message.width = "100%";
 
 	//////////////////////////////////////////////////////////////////////////////////////////////////////
@@ -1168,11 +1171,7 @@
 	option_hide_more.id = 'option_hide_more_'+ID;
 	option_hide_more.onclick = function(){
-		var _height = Element("div_message_scroll_"+ID).style.height;
-		_height = parseInt(_height.replace("px",""));
-		var _offset = 35;
 		if (this.value == 'more_options'){
 			this.innerHTML = "<b><u>"+get_lang('Options')+"</u></b>";
 			this.value = 'hide_options';
-			Element("div_message_scroll_"+ID).style.height = (_height - _offset)+"px";
 			Element('table_message_others_options_'+ID).style.display = '';
 			Element('tr_other_options_'+ID).style.display = '';
@@ -1182,8 +1181,8 @@
 			this.innerHTML = get_lang('Options');
 			this.value = 'more_options';
-			Element("div_message_scroll_"+ID).style.height = (_height + _offset)+"px";
 			Element('table_message_others_options_'+ID).style.display = 'none';
 			Element('tr_other_options_'+ID).style.display = 'none';			
 		}
+		resizeWindow();
 	};
 	var option_mark = document.createElement('TD');
@@ -1382,4 +1381,5 @@
 	var table_message_others_options = document.createElement("TABLE");
 	table_message_others_options.id = 'table_message_others_options_' + ID;
+	table_message_others_options.width = "100%";
 	table_message_others_options.style.display = 'none';
 	table_message_others_options.className = "table_message";
@@ -1703,4 +1703,5 @@
 	div.style.background = 'WHITE';
 	div.style.overflow = "auto";
+	div.style.width = "100%";
 	table_message_others_options.appendChild(tbody_message_others_options);
 	var tr = document.createElement("TR");
@@ -2385,4 +2386,5 @@
 	_div.id = "div_message_scroll_"+ID;
 	_div.style.overflow = "auto";
+	_div.style.width = "100%";
 
 	// Hide the contac tips and re-position the pallete color.