Index: /branches/2.0/phpgwapi/setup/setup.inc.php
===================================================================
--- /branches/2.0/phpgwapi/setup/setup.inc.php	(revision 2541)
+++ /branches/2.0/phpgwapi/setup/setup.inc.php	(revision 2817)
@@ -14,5 +14,5 @@
 	$setup_info['phpgwapi']['name']      = 'phpgwapi';
 	$setup_info['phpgwapi']['title']     = 'phpgwapi';
-	$setup_info['phpgwapi']['version']   = '2.0.005';
+	$setup_info['phpgwapi']['version']   = '2.0.006';
 	$setup_info['phpgwapi']['versions']['current_header'] = '2.0';
 	$setup_info['phpgwapi']['enable']    = 3;
Index: /branches/2.0/phpgwapi/setup/tables_update.inc.php
===================================================================
--- /branches/2.0/phpgwapi/setup/tables_update.inc.php	(revision 2541)
+++ /branches/2.0/phpgwapi/setup/tables_update.inc.php	(revision 2817)
@@ -1696,4 +1696,10 @@
 		$GLOBALS['setup_info']['phpgwapi']['currentver'] = '2.0.005';
 		return $GLOBALS['setup_info']['phpgwapi']['currentver'];
-	}	
+	}
+	$test[] = '2.0.005';
+	function phpgwapi_upgrade2_0_005()
+	{
+		$GLOBALS['setup_info']['phpgwapi']['currentver'] = '2.0.006';
+		return $GLOBALS['setup_info']['phpgwapi']['currentver'];
+	}			
 ?>
Index: /branches/2.0/expressoAdmin1_2/setup/tables_update.inc.php
===================================================================
--- /branches/2.0/expressoAdmin1_2/setup/tables_update.inc.php	(revision 2541)
+++ /branches/2.0/expressoAdmin1_2/setup/tables_update.inc.php	(revision 2817)
@@ -73,3 +73,9 @@
 		return $GLOBALS['setup_info']['expressoAdmin1_2']['currentver'];
 	}	
+	$test[] = '2.0.002';
+	function expressoAdmin1_2_upgrade2_0_002()
+	{
+		$GLOBALS['setup_info']['expressoAdmin1_2']['currentver'] = '2.0.003';
+		return $GLOBALS['setup_info']['expressoAdmin1_2']['currentver'];
+	}	
 ?>
Index: /branches/2.0/expressoAdmin1_2/setup/setup.inc.php
===================================================================
--- /branches/2.0/expressoAdmin1_2/setup/setup.inc.php	(revision 2541)
+++ /branches/2.0/expressoAdmin1_2/setup/setup.inc.php	(revision 2817)
@@ -13,5 +13,5 @@
 	$setup_info['expressoAdmin1_2']['title']     	= 'Expresso Admin';
 	/* Ao incrementar versão, não esquecer de declarar função do tables_update.inc.php*/
-	$setup_info['expressoAdmin1_2']['version']   	= '2.0.002';
+	$setup_info['expressoAdmin1_2']['version']   	= '2.0.003';
 	$setup_info['expressoAdmin1_2']['app_order']	= 1;
 	$setup_info['expressoAdmin1_2']['tables'][]		= 'phpgw_expressoadmin';
Index: /branches/2.0/calendar/setup/setup.inc.php
===================================================================
--- /branches/2.0/calendar/setup/setup.inc.php	(revision 1958)
+++ /branches/2.0/calendar/setup/setup.inc.php	(revision 2817)
@@ -12,5 +12,5 @@
 
 	$setup_info['calendar']['name']    = 'calendar';
-	$setup_info['calendar']['version'] = '2.0.003';
+	$setup_info['calendar']['version'] = '2.0.004';
 	$setup_info['calendar']['app_order'] = 3;
 	$setup_info['calendar']['enable']  = 1;
Index: /branches/2.0/calendar/setup/tables_update.inc.php
===================================================================
--- /branches/2.0/calendar/setup/tables_update.inc.php	(revision 1957)
+++ /branches/2.0/calendar/setup/tables_update.inc.php	(revision 2817)
@@ -81,3 +81,9 @@
 		return $GLOBALS['setup_info']['calendar']['currentver'];
 	}
+	$test[] = '2.0.003';
+	function calendar_upgrade2_0_003()
+	{
+		$GLOBALS['setup_info']['calendar']['currentver'] = '2.0.004';
+		return $GLOBALS['setup_info']['calendar']['currentver'];
+	}	
 ?>
Index: /branches/2.0/expressoMail1_2/setup/tables_update.inc.php
===================================================================
--- /branches/2.0/expressoMail1_2/setup/tables_update.inc.php	(revision 2541)
+++ /branches/2.0/expressoMail1_2/setup/tables_update.inc.php	(revision 2817)
@@ -118,3 +118,8 @@
 		return $setup_info['expressoMail1_2']['currentver'];
 	}	
+	$test[] = '2.0.005';
+	function expressoMail1_2_upgrade2_0_005() {
+		$setup_info['expressoMail1_2']['currentver'] = '2.0.006';
+		return $setup_info['expressoMail1_2']['currentver'];
+	}	
 ?>
Index: /branches/2.0/expressoMail1_2/setup/setup.inc.php
===================================================================
--- /branches/2.0/expressoMail1_2/setup/setup.inc.php	(revision 2541)
+++ /branches/2.0/expressoMail1_2/setup/setup.inc.php	(revision 2817)
@@ -12,5 +12,5 @@
 	$setup_info['expressoMail1_2']['name']      	= 'expressoMail1_2';
 	$setup_info['expressoMail1_2']['title']     	= 'Expresso Mail';
-	$setup_info['expressoMail1_2']['version']   	= '2.0.005';
+	$setup_info['expressoMail1_2']['version']   	= '2.0.006';
 	$setup_info['expressoMail1_2']['app_order'] 	= 2;
 	$setup_info['expressoMail1_2']['tables'][]		= 'phpgw_expressomail_contacts';